#include "docmanager.h"

using namespace moo;

static DocumentManager *mgr_instance;

struct moo::DocumentManagerPrivate {
    DocumentManager::WindowFactory *factory;

    DocumentManagerPrivate() :
        factory(0)
    {
    }

    ~DocumentManagerPrivate()
    {
        delete factory;
    }
};

DocumentManager::DocumentManager() :
    impl(new DocumentManagerPrivate)
{
}

DocumentManager::~DocumentManager()
{
    delete impl;
}

DocumentManager *DocumentManager::instance()
{
    if (!mgr_instance)
        mgr_instance = new DocumentManager;
    return mgr_instance;
}

void DocumentManager::setWindowFactory(WindowFactory *factory)
{
    if (instance()->impl->factory != factory)
    {
        delete instance()->impl->factory;
        instance()->impl->factory = factory;
    }
}

DocumentWindow *DocumentManager::createWindow()
{
    return instance()->impl->factory->createWindow();
}
